// ClientDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CodeWarCppClient_1.h"
#include "ClientDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CClientDlg dialog

CClientDlg::CClientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CClientDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CClientDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CClientDlg)
	DDX_Control(pDX, IDC_CONNECT, m_connect_button);
	DDX_Control(pDX, IDC_EDIT, m_edit);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CClientDlg, CDialog)
	//{{AFX_MSG_MAP(CClientDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CClientDlg message handlers

BOOL CClientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CClientDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CClientDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CClientDlg::Display(const CString &s)
{
    m_edit.ReplaceSel(s);
    m_edit.ReplaceSel("\x0d\x0a");
}

int CClientDlg::DoModal() 
{
	int ret = CDialog::DoModal();	
	return ret;
}

void CClientDlg::OnConnect() 
{
    Display("Please wait, connecting...");
    BeginWaitCursor();
    if(!socket.Create()){
        MessageBox("Cannot create client socket.", "Error", MB_OK | MB_ICONERROR);
        DWORD err = GetLastError();
        std::cerr<<"Cannot create client socket ("<<err<<") "<<__FILE__<<": "<<__LINE__<<std::endl;
        PostQuitMessage(-1);
    }
    std::cout<<"Socket created successfully."<<std::endl;
    Display("Socket created successfully.");
    if(!socket.Connect("127.0.0.1", codewar::connection_port)){
        MessageBox("Cannot connect to server.", "Error", MB_OK | MB_ICONERROR);
        EndWaitCursor();
        DWORD err = GetLastError();
        std::cerr<<"Cannot connect to server ("<<err<<") "<<__FILE__<<": "<<__LINE__<<std::endl;
        Display("Cannot connect to server");
    }
    else{
        m_connect_button.EnableWindow(FALSE);
        std::cout<<"Connected to server."<<std::endl;
        Display("Connected to server.");
        EndWaitCursor();
    }
}
