// CppClientSocket.cpp : implementation file
//

#include "stdafx.h"
#include "CodeWarCppClient_1.h"
#include "CppClientSocket.h"
#include <iomanip>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCppClientSocket

CCppClientSocket::CCppClientSocket():
    stats(10, 10, 10, 10)
{
}

CCppClientSocket::~CCppClientSocket()
{
}


// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(CCppClientSocket, CSocket)
	//{{AFX_MSG_MAP(CCppClientSocket)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0

/////////////////////////////////////////////////////////////////////////////
// CCppClientSocket member functions

void CCppClientSocket::OnConnect(int nErrorCode) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	CSocket::OnConnect(nErrorCode);
}

void CCppClientSocket::OnReceive(int nErrorCode) 
{
    ASSERT(!nErrorCode);
    using namespace codewar;
    msg_head head;
    server_handshake_message sh;
    Receive(&head, sizeof(head), MSG_PEEK);
    switch(head.id){
    case msgid_server_handshake:
        ReceiveServerHandshake();
        break;
    case msgid_creature_feedback:
        ReceiveCreatureFeedback(head);
        break;
    default:
        Flush();
        break;
    }
	CSocket::OnReceive(nErrorCode);
}

void CCppClientSocket::OnClose(int nErrorCode) 
{
	DisplayLine("Connection to server lost");
	CSocket::OnClose(nErrorCode);
}

bool CCppClientSocket::SendCreatureStats()
{
    using namespace codewar;
    creature_stats_message msg(stats);
    Send(&msg, sizeof(msg));
    return true;
}

bool CCppClientSocket::SendClientHandshake(codewar::server_handshake sh)
{
    using namespace codewar;
    client_handshake_message ch(sh.species_id, "C++ base species");
    Send(&ch, sizeof(ch));
    return true;
}

void CCppClientSocket::Flush()
{
    using namespace std;
    unsigned int c;
    CString s;
    s.Format("Flushing socket.");
    DisplayLine(s);
    cout<<"Flushing socket, content was:"<<endl;
    int i = 0;
    while(Receive(&c, sizeof(unsigned int))){
        cout<<setw(8)<<setfill('0')<<hex<<c<<" ";
        if(++i == 5){
            cout<<endl;
            i = 0;
        }
    }
    cout<<endl;
}

void CCppClientSocket::ReceiveCreatureFeedback(codewar::msg_head &head)
{
    using namespace codewar;
    client_feedback_message message;
    message.head = head;
    message.prepare();
    Receive(message.message(), message.size());
    client_feedback_info info;
    info.parse(message.data);
    std::cout<<"Received feedback for creature "<<info.creature.id<<std::endl;
    creatures[info.creature.id] = info;
    if(info.creature.id == creatures.size()-1){
        MakeTurn();
    }
}

bool CCppClientSocket::ReceiveServerHandshake()
{
    using namespace codewar;
    server_handshake_message sh;
    Receive(&sh, sizeof(sh));
    DisplayLine("Server handshake received");
    creatures.resize(sh.handshake.no_of_creatures);
    species = sh.handshake.species_id;
    SendClientHandshake(sh.handshake);
    SendCreatureStats();
    return true;
}

void CCppClientSocket::MakeTurn()
{
    static int turn = 0;
    using namespace codewar;
    //////////////////////////////
    //
    // ai code comes here
    //
    //////////////////////////////
    creature_action_message action;
    for(int i = 0; i<creatures.size(); ++i){
        action.creature = i;
        action.species = species;
        action.action = rest;
        VERIFY(sizeof(action) == Send(&action, sizeof(action)));
    }
    TRACE("Turn %d\n", turn);
    std::cout<<"Turn "<<turn<<std::endl;
    ++turn;
}
